# This function updates the missile position every tick

# get time of flight
scoreboard players add @s missiles.t 1

# get current vertical velocity
scoreboard players operation .temp_1 missiles.temp = @s missiles.v_y0
scoreboard players operation .temp_2 missiles.temp = @s missiles.t
scoreboard players operation .temp_2 missiles.temp *= .10 missiles.constant
scoreboard players operation .temp_2 missiles.temp /= .20 missiles.constant
scoreboard players operation .temp_1 missiles.temp -= .temp_2 missiles.temp
scoreboard players operation @s missiles.v_y = .temp_1 missiles.temp

# get displacement
scoreboard players operation @s missiles.x = @s missiles.x0
scoreboard players operation .temp_1 missiles.temp = @s missiles.v_x0
scoreboard players operation .temp_1 missiles.temp *= @s missiles.t
scoreboard players operation .temp_1 missiles.temp /= .20 missiles.constant
scoreboard players operation .temp_1 missiles.temp *= .-1 missiles.constant
scoreboard players operation @s missiles.x += .temp_1 missiles.temp
execute store result entity @s Pos[0] double 1 run scoreboard players get @s missiles.x

scoreboard players operation @s missiles.y = @s missiles.y0
scoreboard players operation .temp_1 missiles.temp = @s missiles.v_y0
scoreboard players operation .temp_2 missiles.temp = @s missiles.v_y 
scoreboard players operation .temp_1 missiles.temp += .temp_2 missiles.temp
scoreboard players operation .temp_1 missiles.temp /= .2 missiles.constant
scoreboard players operation .temp_1 missiles.temp *= @s missiles.t
scoreboard players operation .temp_1 missiles.temp /= .20 missiles.constant
scoreboard players operation @s missiles.y += .temp_1 missiles.temp
execute store result entity @s Pos[1] double 1 run scoreboard players get @s missiles.y

scoreboard players operation @s missiles.z = @s missiles.z0
scoreboard players operation .temp_1 missiles.temp = @s missiles.v_z0
scoreboard players operation .temp_1 missiles.temp *= @s missiles.t
scoreboard players operation .temp_1 missiles.temp /= .20 missiles.constant
scoreboard players operation .temp_1 missiles.temp *= .-1 missiles.constant
scoreboard players operation @s missiles.z += .temp_1 missiles.temp
execute store result entity @s Pos[2] double 1 run scoreboard players get @s missiles.z

# cosmetic particles
particle minecraft:campfire_signal_smoke ~ ~ ~ 1 1 1 0 10 force
# load chunks
forceload add ~ ~ ~ ~

# check impact
execute if score @s missiles.y <= .-128 missiles.constant run function scripts:projectiles/missile_launcher/hit
execute unless block ~ ~ ~ air positioned over world_surface run function scripts:projectiles/missile_launcher/hit