# Start the function and increment missiles.timer by 1 every tick
scoreboard players add @s missiles.timer 1

# Timer events

# First tick
execute if score @s missiles.timer matches 1..5 run execute store result score @s missiles.tx0 run data get block ~-1 ~ ~-24 Items[{Slot:0b}].tag.missiles.target_x
execute if score @s missiles.timer matches 1..5 run execute store result score @s missiles.tz0 run data get block ~-1 ~ ~-24 Items[{Slot:0b}].tag.missiles.target_z

# 1s - First animation and playsound
execute if score @s missiles.timer matches 20 run function scripts:projectiles/animations/1/check
execute if score @s missiles.timer matches 20 run execute as @a[distance=..48] at @s run playsound minecraft:entity.horse.armor master @a ~ ~ ~ 1 1

# 4s - Second animation and playsound
execute if score @s missiles.timer matches 80 run function scripts:projectiles/animations/2/check
execute if score @s missiles.timer matches 80 run execute as @a[distance=..48] at @s run playsound minecraft:entity.horse.armor master @a ~ ~ ~ 1 0.5

# 7s - Third animation and playsound
execute if score @s missiles.timer matches 140 run function scripts:projectiles/animations/3/check
execute if score @s missiles.timer matches 140 run execute as @a[distance=..48] at @s run playsound minecraft:entity.horse.armor master @a ~ ~ ~ 1 0

# 12.9s - Fourth animation, projectile count
execute if score @s missiles.timer matches 258 run function scripts:projectiles/animations/3/0_heavy
execute if score @s missiles.timer matches 258 run scoreboard players add .amount missiles.projectiles 1

# 13s - Playsound, particle, missile summon and missile id apply
execute if score @s missiles.timer matches 260 run execute as @a[distance=..960] at @s run playsound minecraft:entity.wither.death master @s ~ ~ ~ 1 0
execute if score @s missiles.timer matches 260 run particle minecraft:campfire_cosy_smoke ~ ~ ~ 0 0 0 0.1 250 force
execute if score @s missiles.timer matches 260 run summon minecraft:marker ~ ~ ~ {Tags:["missiles.projectile","missiles.missile","missiles.object"]}
execute if score @s missiles.timer matches 260 run scoreboard players operation @e[type=marker,tag=missiles.missile,sort=nearest,limit=1,distance=..1] missiles.missile_id = @s missiles.missile_id

# 13.1s - Reset missile_id
execute if score @s missiles.timer matches 262 run scoreboard players set @s missiles.missile_id 0

# 16s - Fifth animation and playsound
execute if score @s missiles.timer matches 320 run function scripts:projectiles/animations/2/check
execute if score @s missiles.timer matches 320 run execute as @a[distance=..48] at @s run playsound minecraft:entity.horse.armor master @a ~ ~ ~ 1 0

# 19s - Fifth animation and playsound
execute if score @s missiles.timer matches 380 run function scripts:projectiles/animations/1/check
execute if score @s missiles.timer matches 380 run execute as @a[distance=..48] at @s run playsound minecraft:entity.horse.armor master @a ~ ~ ~ 1 0.5

# 22s - Fifth animation, playsound, remove tag and reset missile.timer
execute if score @s missiles.timer matches 440 run function scripts:projectiles/animations/0/check
execute if score @s missiles.timer matches 440 run execute as @a[distance=..48] at @s run playsound minecraft:entity.horse.armor master @a ~ ~ ~ 1 1
execute if score @s missiles.timer matches 440.. run tag @s remove missiles.loaded
execute if score @s missiles.timer matches 440.. run scoreboard players reset @s missiles.timer